package com.ozs.service.utils;

import com.alibaba.fastjson2.JSON;
import com.alibaba.fastjson2.JSONArray;
import com.alibaba.fastjson2.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.ozs.service.entity.CameraUpdateLog;
import com.ozs.service.service.CameraUpdateLogService;
import org.eclipse.paho.client.mqttv3.IMqttDeliveryToken;
import org.eclipse.paho.client.mqttv3.MqttCallback;
import org.eclipse.paho.client.mqttv3.MqttMessage;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * callback回调：
 *
 * @author Administrator
 */
@Component
public class PublishCallback implements MqttCallback {
    
    @Autowired
    CameraUpdateLogService cameraUpdateLogService;

    //在断开连接时调用
    @Override
    public void connectionLost(Throwable cause) {
        // 连接丢失后，一般在这里面进行重连
        System.out.println("连接断开，可以做重连");
    }

    //接收到已经发布的 QoS 1 或 QoS 2 消息的传递令牌时调用
    @Override
    public void deliveryComplete(IMqttDeliveryToken token) {
        System.out.println("deliveryComplete---------" + token.isComplete());
    }

    //接收已经预订的发布
    @Override
    public void messageArrived(String topic, MqttMessage message) throws Exception {
        String sign = null;
        String deviceSn=null;
        String code=null;
        // subscribe后得到的消息会执行到这里面
        System.out.println("接收消息主题 : " + topic);
        System.out.println("接收消息Qos : " + message.getQos());
        if ("heart".equals(topic)) {
            String s = new String(message.getPayload());
            s = "[" + s + "]";
            JSONArray jsonArray = JSONArray.parseArray(s);
            for (int i = 0; i < jsonArray.size(); i++) {
                JSONObject object = jsonArray.getJSONObject(i);
                sign = (String) object.get("sign");
                deviceSn = (String) object.get("device_sn");
            }
            PublishClient.pull(sign,deviceSn);
        }
        if ("update".equals(topic)) {
            String s = new String(message.getPayload());
            s = "[" + s + "]";
            JSONArray jsonArray = JSONArray.parseArray(s);
            for (int i = 0; i < jsonArray.size(); i++) {
                JSONObject object = jsonArray.getJSONObject(i);
                code = (String) object.get("code");
                deviceSn = (String) object.get("device_sn");
            }
            LambdaQueryWrapper<CameraUpdateLog> wrapper = new LambdaQueryWrapper<>();
            wrapper.eq(CameraUpdateLog::getCameraCode, deviceSn);
            wrapper.orderByDesc(CameraUpdateLog::getCreateTime);
            List<CameraUpdateLog> list = cameraUpdateLogService.list();
            CameraUpdateLog cameraUpdateLog = list.get(0);
            if ("200".equals(code)){
                cameraUpdateLog.setStatus(1);
                cameraUpdateLogService.updateById(cameraUpdateLog);
            }else if ("400".equals(code)){
                cameraUpdateLog.setStatus(3);
                cameraUpdateLogService.updateById(cameraUpdateLog);
            }
        }
        System.out.println("接收消息内容 : " + new String(message.getPayload()));
        
    }
}
